"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ExecutionEnvironment = require('exenv');

function transitionEnd() {
  var transitionEndEventNames = {
    WebkitTransition: 'webkitTransitionEnd',
    MozTransition: 'transitionend',
    OTransition: 'oTransitionEnd otransitionend',
    transition: 'transitionend'
  };

  if (!ExecutionEnvironment.canUseDOM) {
    return transitionEndEventNames;
  }

  var el = document.createElement('pin');

  for (var name in transitionEndEventNames) {
    if (el.style[name] !== undefined) {
      return transitionEndEventNames[name];
    }
  }

  return false;
}

var ifHasTransitionEnd = transitionEnd();
var prefixes = ['Webkit', 'Moz', 'ms', 'O', ''];

var AnimationManager = function () {
  function AnimationManager() {
    _classCallCheck(this, AnimationManager);

    this.animationHandle = "css".concat(ifHasTransitionEnd ? 3 : 2, "Animation");
  }

  _createClass(AnimationManager, [{
    key: "generate",
    value: function generate(options) {
      Object.assign(this, options);
      return this[this.animationHandle]();
    }
  }, {
    key: "css2Animation",
    value: function css2Animation() {
      var style = {};
      style[this.horizontalDirection] = "".concat(this.position[0], "px");

      if (this.verticalDirection === 'bottom') {
        style[this.verticalDirection] = "".concat(this.position[1] + this.itemMargin, "px");
      } else {
        style[this.verticalDirection] = "".concat(this.position[1], "px");
      }

      this.mixAnimation(style);
      return style;
    }
  }, {
    key: "css3Animation",
    value: function css3Animation() {
      var _this = this;

      var style = {};
      prefixes.map(function (prefix) {
        var x, y;

        if (_this.horizontalDirection === 'right') {
          x = _this.containerWidth - _this.size.width - _this.position[0] + _this.itemMargin;
        } else {
          x = _this.position[0];
        }

        if (_this.verticalDirection === 'bottom') {
          y = _this.containerHeight - _this.size.height - _this.position[1];
        } else {
          y = _this.position[1];
        }

        style["".concat(prefix, "Transform")] = "translate3d(".concat(x, "px, ").concat(y, "px, 0)");
      });
      this.mixAnimation(style);
      return style;
    }
  }, {
    key: "mixAnimation",
    value: function mixAnimation(style) {
      var _this2 = this;

      if (!this.closeAnimation) {
        prefixes.map(function (prefix) {
          style["".concat(prefix, "TransitionDuration")] = "".concat(_this2.transitionDuration, "s");
          style["".concat(prefix, "TransitionTimingFunction")] = _this2.transitionTimingFunction;
        });
      }
    }
  }]);

  return AnimationManager;
}();

module.exports = AnimationManager;