"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var React = require('react');

var Core = require('autoresponsive-core');

var GridSort = Core.GridSort;

var AnimationManager = require('./animation');

var noop = function noop() {};

var AutoResponsive = function (_React$Component) {
  _inherits(AutoResponsive, _React$Component);

  var _super = _createSuper(AutoResponsive);

  function AutoResponsive(props) {
    var _this;

    _classCallCheck(this, AutoResponsive);

    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }

  _createClass(AutoResponsive, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      this.sortManager = new GridSort({
        containerWidth: this.props.containerWidth,
        gridWidth: this.props.gridWidth
      });
      this.animationManager = new AnimationManager();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.containerWidth !== nextProps.containerWidth) {
        this.sortManager.changeProps({
          containerWidth: nextProps.containerWidth
        });
      }
    }
  }, {
    key: "setPrivateProps",
    value: function setPrivateProps() {
      this.containerStyle = {
        position: 'relative',
        height: this.containerHeight || 0
      };

      if (typeof this.props.containerHeight === 'number') {
        this.fixedContainerHeight = true;
        this.containerStyle.height = this.props.containerHeight;
      } else {
        this.fixedContainerHeight = false;
      }
    }
  }, {
    key: "UNSAFE_componentWillUpdate",
    value: function UNSAFE_componentWillUpdate() {
      this.sortManager.init();
    }
  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this2 = this;

      return React.Children.map(this.props.children, function (child, childIndex) {
        if (child.props.className && _this2.props.itemClassName && !~child.props.className.indexOf(_this2.props.itemClassName)) {
          return;
        }

        var childWidth = parseInt(child.props.style.width, 10) + _this2.props.itemMargin;

        var childHeight = parseInt(child.props.style.height, 10) + _this2.props.itemMargin;

        var calculatedPosition = _this2.sortManager.getPosition(childWidth, childHeight);

        if (!_this2.fixedContainerHeight && _this2.props.containerWidth) {
          if (calculatedPosition[1] + childHeight > _this2.containerStyle.height) {
            _this2.containerStyle.height = calculatedPosition[1] + childHeight;
          }
        }

        var options = Object.assign({}, _this2.props, {
          position: calculatedPosition,
          size: {
            width: childWidth,
            height: childHeight
          },
          containerHeight: _this2.containerStyle.height,
          itemMargin: _this2.props.itemMargin
        });

        var calculatedStyle = _this2.animationManager.generate(options);

        _this2.mixItemInlineStyle(calculatedStyle);

        _this2.props.onItemDidLayout.call(_this2, child);

        if (childIndex + 1 === _this2.props.children.length) {
          _this2.props.onContainerDidLayout.call(_this2);
        }

        return React.cloneElement(child, {
          style: Object.assign({}, child.props.style, calculatedStyle)
        });
      });
    }
  }, {
    key: "mixItemInlineStyle",
    value: function mixItemInlineStyle(s) {
      var itemMargin = this.props.itemMargin;
      var style = {
        display: 'block',
        "float": 'left',
        margin: "0 ".concat(itemMargin, "px ").concat(itemMargin, "px 0")
      };

      if (this.props.containerWidth) {
        style = {
          position: 'absolute'
        };
      }

      Object.assign(s, style);
    }
  }, {
    key: "getContainerStyle",
    value: function getContainerStyle() {
      return this.containerStyle;
    }
  }, {
    key: "render",
    value: function render() {
      this.setPrivateProps();
      return React.createElement("div", {
        ref: "container",
        className: "".concat(this.props.prefixClassName, "-container"),
        style: this.getContainerStyle()
      }, this.renderChildren());
    }
  }]);

  return AutoResponsive;
}(React.Component);

AutoResponsive.defaultProps = {
  containerWidth: null,
  containerHeight: null,
  gridWidth: 10,
  prefixClassName: 'rc-autoresponsive',
  itemClassName: 'item',
  itemMargin: 0,
  horizontalDirection: 'left',
  transitionDuration: 1,
  transitionTimingFunction: 'linear',
  verticalDirection: 'top',
  closeAnimation: false,
  onItemDidLayout: noop,
  onContainerDidLayout: noop
};
module.exports = AutoResponsive;